import { renderless, api } from '@opentinyvue/vue-renderless/select/vue';
import { defineComponent, directive, props, setup } from '@opentinyvue/vue-common';
import Tag from '@opentinyvue/vue-tag';
import Input from '@opentinyvue/vue-input';
import Option from '@opentinyvue/vue-option';
import Scrollbar from '@opentinyvue/vue-scrollbar';
import SelectDropdown from '@opentinyvue/vue-select-dropdown';
import { Clickoutside } from '@opentinyvue/vue-directive';
import { iconClose, iconCopy, iconHalfselect, iconCheck, iconCheckedSur, iconLoading, iconChevronRight } from '@opentinyvue/vue-icon';
import Tree from '@opentinyvue/vue-tree';
import Tooltip from '@opentinyvue/vue-tooltip';
import FilterBox from '@opentinyvue/vue-filter-box';
import RecycleScroller from '@opentinyvue/vue-recycle-scroller';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var classes = {
  "caret": "text-base rotate-0 transition-transform duration-300 fill-color-text-placeholder cursor-pointer ",
  "select-tags": "absolute leading-normal whitespace-normal sm:pl-3 pr-2 z-[1] top-1/2 -translate-y-2/4 flex items-center flex-wrap [&_[data-tag=tiny-tag]]:my-0.5 [&_[data-tag=tiny-tag]]:h-7 [&_[data-tag=tiny-tag]]:text-sm [&_[data-tag=tiny-tag]]:sm:h-5 [&_[data-tag=tiny-tag]]:sm:text-sm [&_[data-tag=tiny-tag]_svg]:shrink-0",
  "tags-text": "inline-block w-full whitespace-nowrap text-ellipsis overflow-hidden align-bottom",
  "tag-info": "whitespace-nowrap text-ellipsis overflow-hidden inline-flex justify-start items-center border-transparent text-color-text-primary"
};
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", _vm._b({
    directives: [{
      name: "popover",
      rawName: "v-popover:popover",
      arg: "popover"
    }, {
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleClose,
      expression: "handleClose"
    }],
    ref: "select",
    staticClass: "inline-block relative w-full outline-0 group [&_[data-tag=tiny-tag]]:max-w-[144px]",
    class: [_vm.hoverExpand ? "align-top" : "", _vm.$parent.$attrs.class],
    on: {
      "mouseleave": function mouseleave($event) {
        if ($event.target !== $event.currentTarget) return null;
        return (function() {
          _vm.state.selectHover = false;
          _vm.state.inputHovering = false;
        }).apply(null, arguments);
      },
      "mouseenter": function mouseenter($event) {
        if ($event.target !== $event.currentTarget) return null;
        return _vm.onMouseenterSelf.apply(null, arguments);
      },
      "click": _vm.toggleMenu
    }
  }, "div", _vm.a(_vm.$attrs, ["class", "style"], true), false), [_c("div", {
    ref: "tagsGroup",
    class: [{
      "absolute top-0 left-0 right-0": _vm.hoverExpand
    }, {
      "absolute w-full": _vm.state.isExpand && _vm.hoverExpand
    }, {
      "z-[2]": _vm.state.isExpand && _vm.hoverExpand && (_vm.state.inputHovering || _vm.state.visible)
    }],
    style: _vm.state.selectFiexd,
    attrs: {
      "title": _vm.multiple && !_vm.state.selectDisabled && _vm.state.selected.length ? _vm.state.selected.map(function(item) {
        return item.state ? item.state.currentLabel : item.currentLabel;
      }).join("; ") : !_vm.multiple && _vm.state.selectDisabled ? _vm.state.selectedLabel : ""
    }
  }, [_vm.shape === "filter" ? _c("tiny-filter-box", {
    ref: "reference",
    attrs: {
      "show-close": _vm.clearable,
      "placeholder": _vm.placeholder,
      "disabled": _vm.state.selectDisabled,
      "label": _vm.label,
      "tip": _vm.tip,
      "value": _vm.multiple ? _vm.state.selected.map(function(item) {
        return item.state ? item.state.currentLabel : item.currentLabel;
      }).join("; ") : _vm.state.selectedLabel,
      "drop-down-visible": _vm.state.visible,
      "blank": _vm.blank
    },
    on: {
      "click": _vm.toggleMenu
    }
  }) : _vm._e(), _vm.multiple && !_vm.state.isDisplayOnly && !_vm.shape ? _c("div", {
    ref: "tags",
    class: _vm.m(_vm.gcls("select-tags"), {
      "pl-9 sm:pl-9": _vm.slots.prefix
    }, {
      "overflow-y-hidden": (_vm.state.inputHovering || _vm.state.visible) && !_vm.state.selected.length
    }, {
      "h-6 overflow-hidden": _vm.hoverExpand
    }, {
      "pr-6": _vm.state.selectDisabled
    }, {
      "overflow-y-auto max-h-28 h-auto": _vm.hoverExpand && (_vm.state.inputHovering || _vm.state.visible)
    }),
    style: _vm.state.tagsStyle
  }, [!_vm.state.selectDisabled ? _c("span", {
    class: [_vm.collapseTags ? _vm.filterable && _vm.state.device === "pc" ? "w-auto max-w-[76%] flex" : "w-full flex" : "contents"]
  }, [(_vm.collapseTags || _vm.state.device === "mb") && _vm.state.selectedVal.length ? _c("span", {
    class: ["contents", _vm.collapseTags && _vm.filterable ? "max-w-full flex-1" : ""]
  }, [_c("tiny-tag", {
    key: _vm.state.key,
    class: _vm.gcls("tag-info"),
    attrs: {
      "closable": !_vm.state.selectDisabled && _vm.state.device !== "mb",
      "size": _vm.state.collapseTagSize,
      "hit": _vm.state.selectedVal[0].state ? _vm.state.selectedVal[0].state.hitState : _vm.state.selectedVal[0].hitState,
      "type": "info",
      "disable-transitions": ""
    },
    on: {
      "close": function close($event) {
        return _vm.deleteTag($event, _vm.state.selectedVal[0]);
      }
    }
  }, [_c("tiny-tooltip", {
    attrs: {
      "effect": _vm.tooltipConfig.effect || "light",
      "placement": _vm.tooltipConfig.placement || "top",
      "popper-class": _vm.tooltipConfig.popperClass || ""
    },
    nativeOn: {
      "mouseenter": function mouseenter($event) {
        _vm.handleEnterTag($event, _vm.getValueKey(_vm.state.selectedVal[0]));
      }
    },
    scopedSlots: _vm._u([_vm.state.tooltipContent[_vm.getValueKey(_vm.state.selectedVal[0])] ? {
      key: "content",
      fn: function fn() {
        return [_c("span", {
          class: _vm.gcls("tags-text")
        }, [_vm._t("label", function() {
          return [_vm._v(_vm._s(_vm.state.selectedVal[0].state ? _vm.state.selectedVal[0].state.currentLabel : _vm.state.selectedVal[0].currentLabel))];
        }, {
          "item": _vm.getLabelSlotValue(_vm.state.selectedVal[0])
        })], 2)];
      },
      proxy: true
    } : null], null, true)
  }, [_c("span", {
    class: _vm.gcls("tags-text")
  }, [_vm._t("label", function() {
    return [_vm._v(_vm._s(_vm.state.selectedVal[0].state ? _vm.state.selectedVal[0].state.currentLabel : _vm.state.selectedVal[0].currentLabel))];
  }, {
    "item": _vm.getLabelSlotValue(_vm.state.selectedVal[0])
  })], 2)])], 1), _vm.state.selectedVal.length > 1 ? _c("tiny-tag", {
    staticClass: "overflow-visible",
    class: _vm.gcls("tag-info"),
    attrs: {
      "closable": false,
      "size": _vm.state.collapseTagSize,
      "type": "info",
      "disable-transitions": ""
    }
  }, [_c("span", {
    class: _vm.gcls("tags-text")
  }, [_vm._v("+ " + _vm._s(_vm.state.selectedVal.length - 1))])]) : _vm._e()], 1) : _vm._e(), !_vm.collapseTags ? _c("span", {
    ref: "tags-content",
    staticClass: "sm:contents hidden"
  }, [_vm.hoverExpand ? _c("tiny-tag", {
    key: "tags-collapse",
    class: _vm.m(_vm.gcls("tag-info"), {
      "visible static": _vm.hoverExpand
    }, {
      "invisible absolute": _vm.hoverExpand && (_vm.state.inputHovering || _vm.state.visible || _vm.state.isHidden)
    }),
    attrs: {
      "type": "info",
      "data-tag": "tags-collapse",
      "closable": false,
      "size": _vm.state.collapseTagSize
    }
  }, [_vm._v("+ " + _vm._s(_vm.state.collapseTagsLength))]) : _vm._e(), _vm._l(_vm.state.selected, function(item, index) {
    return _c("tiny-tag", {
      key: _vm.getValueKey(item),
      class: _vm.gcls("tag-info"),
      attrs: {
        "closable": !item.selectDisabled && !item.required && _vm.state.device !== "mb",
        "size": _vm.state.collapseTagSize,
        "hit": item.state ? item.state.hitState : item.hitState,
        "type": "info",
        "disable-transitions": ""
      },
      on: {
        "close": function close($event) {
          return _vm.deleteTag($event, item);
        }
      }
    }, [_c("tiny-tooltip", {
      attrs: {
        "effect": _vm.tooltipConfig.effect || "light",
        "placement": _vm.tooltipConfig.placement || "top",
        "popper-class": _vm.tooltipConfig.popperClass || ""
      },
      nativeOn: {
        "mouseenter": function mouseenter($event) {
          _vm.handleEnterTag($event, _vm.getValueKey(item));
        }
      },
      scopedSlots: _vm._u([_vm.state.tooltipContent[_vm.getValueKey(item)] ? {
        key: "content",
        fn: function fn() {
          return [!_vm.state.visible && _vm.state.overflow === index ? _c("span", {
            class: _vm.gcls("tags-text")
          }, [_vm._v(_vm._s(item.state ? item.state.currentLabel + "... " : item.currentLabel + "... "))]) : _c("span", {
            class: _vm.gcls("tags-text")
          }, [_vm._t("label", function() {
            return [_vm._v(_vm._s(item.state ? item.state.currentLabel : item.currentLabel))];
          }, {
            "item": _vm.getLabelSlotValue(item)
          })], 2)];
        },
        proxy: true
      } : null], null, true)
    }, [!_vm.state.visible && _vm.state.overflow === index ? _c("span", {
      class: _vm.gcls("tags-text")
    }, [_vm._v(_vm._s(item.state ? item.state.currentLabel + "... " : item.currentLabel + "... "))]) : _c("span", {
      class: _vm.gcls("tags-text")
    }, [_vm._t("label", function() {
      return [_vm._v(_vm._s(item.state ? item.state.currentLabel : item.currentLabel))];
    }, {
      "item": _vm.getLabelSlotValue(item)
    })], 2)])], 1);
  })], 2) : _vm._e()]) : _c("span", {
    class: [_vm.gcls("tags-text"), "flex"]
  }, [_c("tiny-tooltip", {
    attrs: {
      "effect": _vm.tooltipConfig.effect || "light",
      "placement": _vm.tooltipConfig.placement || "top",
      "disabled": !_vm.showTips || _vm.state.device === "mb",
      "popper-class": _vm.tooltipConfig.popperClass || ""
    },
    scopedSlots: _vm._u([{
      key: "content",
      fn: function fn() {
        return [_c("div", {
          class: [_vm.state.showTips && "max-h-[theme(spacing.72)] overflow-x-hidden w-full", "inline-block"]
        }, [_vm.slots.label ? _c("span", _vm._l(_vm.state.selected, function(item) {
          return _c("span", {
            key: _vm.getValueKey(item)
          }, [_vm._t("label", null, {
            "item": item
          })], 2);
        }), 0) : _c("span", [_vm._v(_vm._s(_vm.disabledTooltipContent || _vm.state.disabledTooltipContent))])])];
      },
      proxy: true
    }], null, true)
  }, [_c("span", {
    staticClass: "inline-block w-full whitespace-nowrap text-ellipsis overflow-hidden text-color-text-disabled"
  }, _vm._l(_vm.state.selected, function(item) {
    return _c("span", {
      key: item.value
    }, [_vm._t("label", function() {
      return [_vm._v(_vm._s(item.state ? item.state.currentLabel : item.currentLabel))];
    }, {
      "item": item
    }), _vm._v("; ")], 2);
  }), 0)])], 1), _vm.filterable && !_vm.state.selectDisabled ? _c("input", {
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.state.query,
      expression: "state.query"
    }],
    ref: "input",
    staticClass: "hidden sm:inline-block border-none outline-0 p-0 ml-px text-color-text-primary text-xs h-7 appearance-none bg-transparent",
    class: [_vm.state.selectSize === "mini" ? "h-6" : "", _vm.state.selectSize === "small" ? "h-9" : "", _vm.state.selectSize === "medium" ? "h-8" : ""],
    style: {
      "flex-grow": "1",
      width: _vm.state.inputLength / (_vm.state.inputWidth - 32) + "%",
      "max-width": _vm.state.inputWidth - 42 + "px",
      height: "auto"
    },
    attrs: {
      "type": "text",
      "disabled": _vm.state.selectDisabled,
      "autocomplete": _vm.autocomplete
    },
    domProps: {
      "value": _vm.state.query
    },
    on: {
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "keyup": _vm.managePlaceholder,
      "keydown": [_vm.resetInputState, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) return null;
        $event.preventDefault();
        return _vm.navigateOptions("next");
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) return null;
        $event.preventDefault();
        return _vm.navigateOptions("prev");
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
        $event.preventDefault();
        return _vm.selectOption.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) return null;
        $event.stopPropagation();
        $event.preventDefault();
        _vm.state.visible = false;
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "delete", [8, 46], $event.key, ["Backspace", "Delete", "Del"])) return null;
        return _vm.deletePrevTag.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) return null;
        _vm.state.visible = false;
      }],
      "compositionstart": _vm.handleComposition,
      "compositionupdate": _vm.handleComposition,
      "compositionend": _vm.handleComposition,
      "input": [function($event) {
        if ($event.target.composing) return;
        _vm.$set(_vm.state, "query", $event.target.value);
      }, _vm.debouncedQueryChange]
    }
  }) : _vm._e()]) : _vm._e(), !_vm.shape ? _c("tiny-input", {
    ref: "reference",
    attrs: {
      "type": "text",
      "placeholder": _vm.state.currentPlaceholder,
      "name": _vm.name,
      "id": _vm.id,
      "autocomplete": _vm.autocomplete,
      "size": _vm.state.selectSize,
      "disabled": _vm.state.selectDisabled,
      "readonly": _vm.state.readonly,
      "display-only": _vm.state.isDisplayOnly,
      "display-only-content": _vm.state.displayOnlyContent,
      "unselectable": _vm.state.readonly ? "on" : "off",
      "validate-event": false,
      "tabindex": _vm.multiple && _vm.filterable ? "-1" : _vm.tabindex,
      "show-empty-value": _vm.showEmptyValue
    },
    on: {
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "keyup": _vm.debouncedOnInputChange,
      "keydown": [function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) return null;
        $event.stopPropagation();
        $event.preventDefault();
        return _vm.navigateOptions("next");
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) return null;
        $event.stopPropagation();
        $event.preventDefault();
        return _vm.navigateOptions("prev");
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
        $event.preventDefault();
        return _vm.selectOption.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) return null;
        $event.stopPropagation();
        $event.preventDefault();
        _vm.state.visible = false;
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) return null;
        _vm.state.visible = false;
      }],
      "paste": _vm.debouncedOnInputChange,
      "mouseenter": _vm.onMouseenterNative,
      "mouseleave": _vm.onMouseleaveNative
    },
    nativeOn: {
      "compositionend": function compositionend($event) {
        return _vm.handleComposition.apply(null, arguments);
      }
    },
    scopedSlots: _vm._u([_vm.slots.prefix ? {
      key: "prefix",
      fn: function fn() {
        return [_vm._t("prefix")];
      },
      proxy: true
    } : null, {
      key: "suffix",
      fn: function fn() {
        return [_vm._t("suffix"), _vm.state.showCopy ? _c("span", {
          staticClass: "h-4 cursor-pointer relative z-[1]",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.handleCopyClick.apply(null, arguments);
            }
          }
        }, [_c("icon-copy", {
          class: [_vm.gcls("caret"), "align-top group-hover:fill-color-brand"]
        })], 1) : _vm._e(), _vm.showProportion && _vm.state.selected.length > 0 && _vm.state.options.length > 1 ? _c("span", [_vm._v(" " + _vm._s(_vm.state.selected.length + "/" + _vm.state.options.length) + " ")]) : _vm._e(), _vm.state.showClose ? _c("icon-close", {
          class: [_vm.gcls("caret"), "hidden sm:inline-block", {
            "mr-2 fill-color-text-placeholder hover:fill-color-icon-primary": _vm.state.showClose
          }, {
            "mr-1": _vm.multiple && _vm.state.showClose
          }],
          on: {
            "click": _vm.handleClearClick,
            "mouseenter": function mouseenter($event) {
              _vm.state.inputHovering = true;
            }
          }
        }) : _vm._e(), _c(_vm.state.getIcon.icon, {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: !(_vm.remote && _vm.filterable && !_vm.remoteConfig.showIcon),
            expression: "!(remote && filterable && !remoteConfig.showIcon)"
          }],
          tag: "component",
          class: _vm.m(_vm.gcls("caret"), "hidden sm:inline-block", _vm.state.iconClass, {
            "hidden": _vm.state.selectDisabled
          }, {
            "fill-color-brand-hover rotate-180 ": _vm.state.visible
          }),
          on: {
            "click": _vm.handleDropdownClick
          }
        }), _c("icon-chevron-right", {
          staticClass: "inline-block sm:hidden",
          class: [_vm.state.selectDisabled ? "fill-color-icon-placeholder sm:fill-color-icon-disabled" : "fill-color-icon-secondary"],
          attrs: {
            "custom-class": "h-5 w-5 sm:h-4 sm:w-4"
          }
        })];
      },
      proxy: true
    }], null, true),
    model: {
      value: _vm.state.selectedLabel,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "selectedLabel", $$v);
      },
      expression: "state.selectedLabel"
    }
  }) : _vm._e(), _c("transition", {
    on: {
      "before-enter": _vm.handleMenuEnter,
      "after-leave": _vm.doDestroy
    }
  }, [_c("tiny-select-dropdown", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.onCopying() && !_vm.hideDrop && _vm.state.visible && _vm.state.emptyText !== false,
      expression: "!onCopying() && !hideDrop && state.visible && state.emptyText !== false"
    }],
    ref: "popper",
    class: _vm.m("duration-300"),
    style: _vm.dropStyle,
    attrs: {
      "title": _vm.title,
      "close-by-mask": _vm.closeByMask,
      "search-placeholder": _vm.searchPlaceholder,
      "is-drop-inherit-width": _vm.isDropInheritWidth,
      "placement": _vm.placement,
      "append-to-body": _vm.popperAppendToBody,
      "popper-options": _vm.popperOptions,
      "height": _vm.dropdownHeight
    }
  }, [_vm.shape && _vm.filterable ? _c("div", {
    staticClass: "px-3 pt-3 pb-1 hidden sm:block",
    class: [_vm.remote && !_vm.state.options.length ? "pb-3" : ""]
  }, [_c("tiny-input", {
    ref: "input",
    attrs: {
      "type": "text",
      "placeholder": _vm.placeholder,
      "autofocus": ""
    },
    on: {
      "input": _vm.debouncedQueryChange,
      "focus": _vm.handleFocus
    },
    model: {
      value: _vm.state.query,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "query", $$v);
      },
      expression: "state.query"
    }
  })], 1) : _vm._e(), _vm.renderType === "tree" ? _c("tiny-tree", _vm._b({
    ref: "selectTree",
    staticClass: "[&_[data-tag=tiny-checkbox]_>span_>span]:p-1.5 sm:[&_[data-tag=tiny-checkbox]_>span_>span]:p-0 sm:max-h-56 overflow-auto",
    attrs: {
      "filter-node-method": _vm.filterMethod,
      "props": Object.assign({
        label: _vm.textField,
        isLeaf: "isLeaf"
      }, _vm.treeOp.props),
      "expand-on-click-node": false,
      "icon-trigger-click-node": false,
      "node-key": _vm.valueField,
      "default-expand-all": _vm.state.isExpandAll,
      "check-strictly": _vm.treeOp.checkStrictly,
      "default-checked-keys": _vm.multiple ? _vm.state.defaultCheckedKeys : _vm.treeOp.defaultCheckedKeys || [],
      "current-node-key": !_vm.multiple ? _vm.state.currentKey : "",
      "show-checkbox": _vm.multiple,
      "show-checked-mark": _vm.state.device === "mb"
    },
    on: {
      "load-data": _vm.loadTreeData,
      "node-collapse": _vm.nodeCollapse,
      "node-expand": _vm.nodeExpand,
      "check": _vm.nodeCheckClick,
      "node-click": _vm.treeNodeClick
    }
  }, "tiny-tree", _vm.treeOp, false)) : _vm._e(), _vm.optimization && _vm.renderType !== "tree" ? [_c("div", {
    style: {
      height: _vm.state.optimizeStore.recycleScrollerHeight + "px"
    }
  }, [_c("tiny-recycle-scroller", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.emptyFlag && !_vm.loading,
      expression: "!state.emptyFlag && !loading"
    }],
    ref: "scrollbar",
    staticStyle: {
      "height": "100%"
    },
    attrs: {
      "key-field": _vm.valueField,
      "list-class": ["tiny-select-dropdown__wrap sm:max-h-56 pb-1 sm:pb-0", _vm.state.device === "mb" ? "scrollbar-size-0" : ""],
      "items": _vm.state.datas,
      "item-size": _vm.state.optimizeOpts.optionHeight
    },
    scopedSlots: _vm._u([{
      key: "before",
      fn: function fn() {
        return [_vm.state.showNewOption ? _c("tiny-option", {
          attrs: {
            "highlightClass": "sm:mb-0",
            "created": "",
            "value": _vm.state.device === "mb" ? _vm.state.queryValue : _vm.state.query
          }
        }) : _vm._e()];
      },
      proxy: true
    }, {
      key: "default",
      fn: function fn(_ref) {
        var item = _ref.item;
        return [_vm._t("default", function() {
          return [_c("tiny-option", {
            key: "" + item[_vm.valueField],
            class: ["absolute w-full"],
            attrs: {
              "label": item[_vm.textField],
              "value": item[_vm.valueField],
              "disabled": item.disabled,
              "required": item.required,
              "highlight-class": item._highlightClass,
              "events": item.events
            },
            on: {
              "mousedown": function mousedown($event) {
                $event.stopPropagation();
              }
            }
          })];
        }, {
          "item": item
        })];
      }
    }], null, true)
  })], 1)] : _vm._e(), !_vm.optimization && _vm.renderType !== "tree" ? _c("tiny-scrollbar", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.options.length > 0 && !_vm.loading,
      expression: "state.options.length > 0 && !loading"
    }],
    ref: "scrollbar",
    attrs: {
      "tag": "ul",
      "wrap-class": ["tiny-select-dropdown__wrap sm:max-h-56 pb-1 sm:pb-0", _vm.state.device === "mb" ? "scrollbar-size-0" : ""],
      "view-class": ["tiny-select-dropdown__list"]
    },
    on: {
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      }
    }
  }, [_vm._t("dropdown"), _vm.multiple && _vm.showCheck && _vm.showAlloption && !_vm.state.multipleLimit && !_vm.state.query && !_vm.remote ? _c("div", {
    staticClass: "whitespace-nowrap box-border py-0 h-10 leading-10 sm:h-8 sm:leading-8 text-sm sm:text-xs pl-0 pr-3 sm:px-3 my-1 sm:m-1 rounded cursor-pointer",
    class: [{
      hover: _vm.state.hoverIndex === -9 && _vm.state.selectCls !== "checked-sur"
    }, {
      "text-color-brand sm:bg-color-fill-6 bg-color-bg-1": _vm.state.selectCls === "checked-sur"
    }],
    attrs: {
      "data-tag": "tiny-option"
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.toggleCheckAll(false);
      },
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      },
      "mouseenter": function mouseenter($event) {
        _vm.state.hoverIndex = -9;
      }
    }
  }, [_c("icon-" + _vm.state.selectCls, {
    tag: "component",
    class: _vm.m(["-mt-0.5 mr-2 fill-color-icon-secondary", _vm.state.selectCls !== "check" && "fill-color-brand"])
  }), _c("span", {
    class: [_vm.state.selectCls === "checked-sur" ? "text-color-brand" : "text-color-text-primary"]
  }, [_vm._v(" " + _vm._s(_vm.allText || _vm.t("ui.base.all")))])], 1) : _vm._e(), _vm.multiple && _vm.showCheck && _vm.showAlloption && !_vm.state.multipleLimit && _vm.state.query && !_vm.state.emptyText && !_vm.remote ? _c("div", {
    staticClass: "whitespace-nowrap box-border py-0 h-10 leading-10 sm:h-8 sm:leading-8 text-sm sm:text-xs pl-0 pr-3 sm:px-3 my-1 sm:m-1 rounded cursor-pointer",
    class: [{
      hover: _vm.state.hoverIndex === -9 && _vm.state.filteredSelectCls !== "checked-sur"
    }, {
      "text-color-brand sm:bg-color-fill-6 bg-color-bg-1": _vm.state.filteredSelectCls === "checked-sur"
    }],
    attrs: {
      "data-tag": "tiny-option"
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.toggleCheckAll(true);
      },
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      },
      "mouseenter": function mouseenter($event) {
        _vm.state.hoverIndex = -9;
      }
    }
  }, [_c("icon-" + _vm.state.filteredSelectCls, {
    tag: "component",
    class: _vm.m(["-mt-0.5 mr-2 fill-color-icon-secondary", _vm.state.filteredSelectCls !== "check" && "fill-color-brand"])
  }), _c("span", {
    class: [_vm.state.filteredSelectCls === "checked-sur" ? "text-color-brand" : "text-color-text-primary"]
  }, [_vm._v(_vm._s(_vm.allText || _vm.t("ui.base.all")))])], 1) : _vm._e(), _vm.state.showNewOption ? _c("tiny-option", {
    attrs: {
      "value": _vm.state.device === "mb" ? _vm.state.queryValue : _vm.state.query,
      "created": ""
    }
  }) : _vm._e(), _vm._t("default", function() {
    return _vm._l(_vm.state.datas, function(item) {
      return _c("tiny-option", {
        key: "" + item[_vm.valueField],
        class: ["relative"],
        attrs: {
          "label": item[_vm.textField],
          "value": item[_vm.valueField],
          "disabled": item.disabled,
          "required": item.required,
          "highlight-class": item._highlightClass,
          "events": item.events
        },
        on: {
          "mousedown": function mousedown($event) {
            $event.stopPropagation();
          }
        }
      });
    });
  })], 2) : _vm._e(), _vm.renderType !== "tree" && _vm.state.emptyText && (!_vm.allowCreate || _vm.loading || _vm.allowCreate && _vm.state.emptyFlag) ? [_vm.loadingText || _vm.slots.empty ? _c("div", [_vm.slots.empty ? _vm._t("empty") : _c("p", {
    staticClass: "py-2.5 px-0 m-0 text-center text-color-text-secondary text-xs"
  }, [_vm._v(" " + _vm._s(_vm.state.emptyText) + " ")])], 2) : _c("div", {
    staticClass: "text-center py-2.5 px-0"
  }, [!_vm.loading ? _c("span", {
    staticClass: "py-2.5 px-0 m-0 text-center text-color-text-secondary text-xs"
  }, [_vm._v(" " + _vm._s(_vm.state.emptyText) + " ")]) : _c("icon-loading", {
    staticClass: "fill-color-brand h-4 w-4 inline-block align-top animate-spin"
  })], 1)] : _vm._e()], 2)], 1)], 1), _vm.hoverExpand && !_vm.state.isDisplayOnly ? _c("div", {
    class: _vm.m("h-7 invisible", {
      "h-6": _vm.state.selectSize === "mini"
    }, {
      "h-7": _vm.state.selectSize === "small"
    }, {
      "h-8": _vm.state.selectSize === "medium"
    })
  }, [_c("input", {
    attrs: {
      "disabled": ""
    }
  })]) : _vm._e()]);
};
var staticRenderFns = [];
var getReference = function getReference2(el, binding, vnode) {
  var _ref = binding.expression ? binding.value : binding.arg;
  var popper = vnode.context.$refs[_ref];
  if (popper) {
    if (Array.isArray(popper)) {
      popper[0].$refs.reference = el;
    } else {
      popper.$refs.reference = el;
    }
  }
};
var __vue2_script = defineComponent({
  inheritAttrs: false,
  emits: ["update:modelValue", "change", "focus", "blur", "clear", "remove-tag", "visible-change", "handleDropdownClick", "dropdown-click", "confirm"],
  directives: directive({
    Clickoutside,
    popover: {
      bind: function bind(el, binding, vnode) {
        getReference(el, binding, vnode);
      },
      inserted: function inserted(el, binding, vnode) {
        getReference(el, binding, vnode);
      }
    }
  }),
  components: {
    TinyTag: Tag,
    TinyInput: Input,
    TinyOption: Option,
    TinyTree: Tree,
    TinyScrollbar: Scrollbar,
    TinyFilterBox: FilterBox,
    TinyTooltip: Tooltip,
    IconClose: iconClose(),
    IconCopy: iconCopy(),
    TinySelectDropdown: SelectDropdown,
    IconHalfselect: iconHalfselect(),
    IconCheck: iconCheck(),
    IconCheckedSur: iconCheckedSur(),
    IconLoading: iconLoading(),
    IconChevronRight: iconChevronRight(),
    TinyRecycleScroller: RecycleScroller
  },
  props: [].concat(props, ["id", "multiple", "name", "dataset", "readonly", "tabindex", "dropStyle", "valueField", "textField", "copyable", "size", "options", "showCheck", "showAlloption", "showProportion", "hideDrop", "modelValue", "showOverflowTooltip", "remote", "remoteConfig", "placement", "loading", "disabled", "valueKey", "clearable", "noDataText", "filterable", "loadingText", "noMatchText", "popperClass", "allowCreate", "placeholder", "remoteMethod", "filterMethod", "collapseTags", "autocomplete", "multipleLimit", "reserveKeyword", "automaticDropdown", "defaultFirstOption", "popperAppendToBody", "showDropdown", "expandTags", "renderType", "gridOp", "treeOp", "delay", "cacheOp", "isDropInheritWidth", "tagSelectable", "selectConfig", "radioConfig", "allowCopy", "textSplit", "autoClose", "queryDebounce", "ignoreEnter", "dropdownIcon", "disabledTooltipContent", "hoverExpand", "optimization", "displayOnly", "initQuery", "extraQueryParams", "shape", "label", "tip", "updateDelay", "showTips", "popperOptions", "title", "closeByMask", "searchPlaceholder", "initLabel", "blank", "showEmptyValue", "tooltipConfig", "dropdownHeight", "allText"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      classes
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
