import { renderless, api } from '@opentinyvue/vue-renderless/select/vue';
import { defineComponent, directive, props, setup } from '@opentinyvue/vue-common';
import Tag from '@opentinyvue/vue-tag';
import Input from '@opentinyvue/vue-input';
import Option from '@opentinyvue/vue-option';
import Scrollbar from '@opentinyvue/vue-scrollbar';
import SelectDropdown from '@opentinyvue/vue-select-dropdown';
import Button from '@opentinyvue/vue-button';
import { Clickoutside } from '@opentinyvue/vue-directive';
import { iconClose, iconCopy, iconAddCircle, iconLoadingShadow, iconHalfselect, iconCheck, iconCheckedSur, iconSearch, iconDownWard, iconEllipsis, iconChevronUp } from '@opentinyvue/vue-icon';
import Grid from '@opentinyvue/vue-grid';
import Tree from '@opentinyvue/vue-tree';
import Tooltip from '@opentinyvue/vue-tooltip';
import FilterBox from '@opentinyvue/vue-filter-box';
import RecycleScroller from '@opentinyvue/vue-recycle-scroller';
import '@opentinyvue/vue-theme/select/index.css';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var getReference = function getReference2(el, binding, vnode) {
  var _ref = binding.expression ? binding.value : binding.arg;
  var popper = vnode.context.$refs[_ref];
  if (popper) {
    if (Array.isArray(popper)) {
      popper[0].$refs.reference = el;
    } else {
      popper.$refs.reference = el;
    }
  }
};
var __vue2_script = defineComponent({
  emits: ["update:modelValue", "change", "focus", "blur", "clear", "remove-tag", "visible-change", "handleDropdownClick", "dropdown-click", "top-create-click"],
  directives: directive({
    Clickoutside,
    popover: {
      bind: function bind(el, binding, vnode) {
        getReference(el, binding, vnode);
      },
      inserted: function inserted(el, binding, vnode) {
        getReference(el, binding, vnode);
      }
    }
  }),
  components: {
    TinyTag: Tag,
    TinyInput: Input,
    TinyOption: Option,
    TinyGrid: Grid,
    TinyTree: Tree,
    TinyButton: Button,
    IconClose: iconClose(),
    TinyScrollbar: Scrollbar,
    IconCopy: iconCopy(),
    IconAddCircle: iconAddCircle(),
    IconLoadingShadow: iconLoadingShadow(),
    TinySelectDropdown: SelectDropdown,
    IconHalfselect: iconHalfselect(),
    IconCheck: iconCheck(),
    IconCheckedSur: iconCheckedSur(),
    TinyFilterBox: FilterBox,
    TinyTooltip: Tooltip,
    TinyRecycleScroller: RecycleScroller,
    // tiny 新增，
    IconSearch: iconSearch(),
    IconDownWard: iconDownWard(),
    // 默认下拉图标
    IconEllipsis: iconEllipsis(),
    IconChevronUp: iconChevronUp()
  },
  props: [].concat(props, [
    "id",
    "multiple",
    "name",
    "dataset",
    "readonly",
    "tabindex",
    "dropStyle",
    "valueField",
    "textField",
    "copyable",
    "size",
    "options",
    "showCheck",
    "showAlloption",
    "hideDrop",
    "modelValue",
    "showOverflowTooltip",
    "remote",
    "remoteConfig",
    "placement",
    "loading",
    "disabled",
    "valueKey",
    "clearable",
    "noDataText",
    "filterable",
    "loadingText",
    "noMatchText",
    "popperClass",
    "allowCreate",
    "placeholder",
    "remoteMethod",
    "filterMethod",
    "collapseTags",
    "autocomplete",
    "multipleLimit",
    "reserveKeyword",
    "automaticDropdown",
    "defaultFirstOption",
    "popperAppendToBody",
    "showDropdown",
    "expandTags",
    "renderType",
    "gridOp",
    "treeOp",
    "delay",
    "cacheOp",
    "isDropInheritWidth",
    "tagSelectable",
    "selectConfig",
    "radioConfig",
    "allowCopy",
    "textSplit",
    "autoClose",
    "queryDebounce",
    "ignoreEnter",
    "dropdownIcon",
    "disabledTooltipContent",
    "hoverExpand",
    "optimization",
    "displayOnly",
    "initQuery",
    "extraQueryParams",
    "shape",
    "label",
    "tip",
    "updateDelay",
    "showTips",
    "popperOptions",
    "trim",
    "topCreate",
    "topCreateText",
    "keepFocus",
    "initLabel",
    "blank",
    "tooltipConfig",
    "showEmptyValue",
    "stopPropagation",
    // 以下为 tiny 新增
    "searchable",
    "showEmptyImage",
    "inputBoxType",
    "tagType",
    "clearNoMatchValue",
    "showLimitText",
    "showProportion",
    "clickExpand",
    "maxVisibleRows",
    "showAllTextTag",
    "allText"
  ]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm$state$designConfi, _vm$state$designConfi2;
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "popover",
      rawName: "v-popover:popover",
      arg: "popover"
    }, {
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleClose,
      expression: "handleClose"
    }],
    ref: "select",
    staticClass: "tiny-select",
    class: [_vm.state.selectSize ? "tiny-select--" + _vm.state.selectSize : "", _vm.state.collapseTags ? "tiny-select__collapse-tags" : "", _vm.filterable ? "tiny-select__filterable" : "", _vm.multiple ? "tiny-select__multiple" : "", (_vm.state.inputHovering || _vm.state.visible) && !_vm.clickExpand ? "is-hover" : "", _vm.state.isDisplayOnly ? "is-display-only" : "", _vm.hoverExpand ? "is-hover-expand" : "", _vm.clickExpand ? "is-click-expand" : "", _vm.state.showCollapseTag ? "collapse-tag-clicked" : "", _vm.state.isDisabled ? "is-disabled" : ""],
    on: {
      "mouseleave": function mouseleave($event) {
        if ($event.target !== $event.currentTarget) return null;
        return (function() {
          _vm.state.selectHover = false;
          _vm.state.inputHovering = false;
        }).apply(null, arguments);
      },
      "mouseenter": function mouseenter($event) {
        if ($event.target !== $event.currentTarget) return null;
        return _vm.onMouseenterSelf.apply(null, arguments);
      },
      "click": _vm.toggleMenu
    }
  }, [_c("div", {
    ref: "tagsGroup",
    class: ["tiny-select__tags-group", {
      "is-expand": _vm.state.isExpand
    }],
    style: _vm.state.selectFiexd,
    attrs: {
      "title": _vm.state.displayOnlyContent
    }
  }, [_vm._t("reference", function() {
    return [_vm.shape === "filter" ? _c("tiny-filter-box", {
      ref: "reference",
      attrs: {
        "show-close": _vm.clearable,
        "placeholder": _vm.placeholder,
        "disabled": _vm.state.selectDisabled,
        "label": _vm.label,
        "tip": _vm.tip,
        "value": _vm.multiple ? _vm.state.selected.map(function(item) {
          return item.state ? item.state.currentLabel : item.currentLabel;
        }).join("; ") : _vm.state.selectedLabel,
        "drop-down-visible": _vm.state.visible,
        "blank": _vm.blank
      },
      on: {
        "click": _vm.toggleMenu
      }
    }) : _vm._e(), _vm.multiple && !_vm.state.isDisplayOnly && !_vm.shape ? _c("div", {
      ref: "tags",
      class: ["tiny-select__tags", {
        "is-showicon": _vm.slots.prefix,
        "not-selected": !_vm.state.selected.length
      }, {
        "is-show-tag": !_vm.state.isShowTagText
      }],
      style: _vm.state.tagsStyle
    }, [!_vm.state.isShowTagText ? _c("span", [_vm.collapseTags && _vm.state.selected.length ? _c("span", [_c("tiny-tag", {
      key: _vm.state.key,
      class: {
        "is-required": _vm.state.selected[0].required
      },
      attrs: {
        "closable": _vm.isTagClosable(_vm.state.selected[0]),
        "size": _vm.state.collapseTagSize,
        "hit": _vm.state.selected[0].state ? _vm.state.selected[0].state.hitState : _vm.state.selected[0].hitState,
        "disabled": _vm.state.selected[0].disabled || _vm.state.isDisabled,
        "type": _vm.state.getTagType,
        "disable-transitions": ""
      },
      on: {
        "close": function close($event) {
          return _vm.deleteTag($event, _vm.state.selected[0]);
        }
      }
    }, [_c("tiny-tooltip", {
      attrs: {
        "effect": _vm.tooltipConfig.effect || "light",
        "placement": _vm.tooltipConfig.placement || "top",
        "popper-class": _vm.tooltipConfig.popperClass || ""
      },
      nativeOn: {
        "mouseenter": function mouseenter($event) {
          _vm.handleEnterTag($event, _vm.getValueKey(_vm.state.selected[0]));
        }
      },
      scopedSlots: _vm._u([{
        key: "content",
        fn: function fn() {
          return [_vm.state.tooltipContent[_vm.getValueKey(_vm.state.selected[0])] ? _c("span", [_vm._t("label", function() {
            return [_vm._v(" " + _vm._s(_vm.state.selected[0].state ? _vm.state.selected[0].state.currentLabel : _vm.state.selected[0].currentLabel) + " ")];
          }, {
            "item": _vm.getLabelSlotValue(_vm.state.selected[0])
          })], 2) : _vm._e()];
        },
        proxy: true
      }], null, true)
    }, [_c("span", {
      staticClass: "tiny-select__tags-text"
    }, [_vm._t("label", function() {
      return [_vm._v(_vm._s(_vm.state.selected[0].state ? _vm.state.selected[0].state.currentLabel : _vm.state.selected[0].currentLabel))];
    }, {
      "item": _vm.getLabelSlotValue(_vm.state.selected[0])
    })], 2)])], 1), _vm.state.selected.length > 1 ? _c("tiny-tag", {
      staticClass: "tiny-select__tags-number",
      attrs: {
        "closable": false,
        "size": _vm.state.collapseTagSize,
        "type": _vm.state.getTagType,
        "disabled": _vm.state.isDisabled,
        "disable-transitions": ""
      }
    }, [_c("span", {
      staticClass: "tiny-select__tags-text"
    }, [_vm._v("+ " + _vm._s(_vm.state.selected.length - 1))])]) : _vm._e()], 1) : _vm._e(), !_vm.collapseTags ? _c("span", {
      ref: "tags-content"
    }, [_vm.showAllTextTag && _vm.state.selectCls === "checked-sur" ? _c("tiny-tag", {
      key: "tags-all-text-tag",
      attrs: {
        "type": _vm.state.getTagType,
        "data-tag": "tags-all-text-tag",
        "disabled": _vm.state.isDisabled,
        "closable": true,
        "size": _vm.state.collapseTagSize
      },
      on: {
        "close": function close($event) {
          return _vm.toggleCheckAll(false);
        }
      }
    }, [_vm._v(" " + _vm._s(_vm.allText || _vm.t("ui.base.all")) + " ")]) : [_vm.hoverExpand || _vm.clickExpand ? _c("tiny-tag", {
      key: "tags-collapse",
      class: ["tiny-select__tags-collapse", {
        "is-hidden": _vm.state.isHidden || _vm.state.isDisabled
      }],
      attrs: {
        "type": _vm.state.getTagType,
        "data-tag": "tags-collapse",
        "only-icon": !_vm.hoverExpand,
        "closable": false,
        "size": _vm.state.collapseTagSize
      },
      on: {
        "click": function click($event) {
          return _vm.onClickCollapseTag($event);
        }
      }
    }, [_vm.hoverExpand ? [_vm._v(" + " + _vm._s(_vm.state.collapseTagsLength) + " ")] : _c("icon-ellipsis")], 2) : _vm._e(), _vm._l(_vm.state.selected, function(item, index) {
      return _c("tiny-tag", {
        key: _vm.getValueKey(item),
        class: {
          "not-visible": _vm.state.toHideIndex <= index && !_vm.state.isExpand,
          "is-required": item.required
        },
        attrs: {
          "closable": _vm.isTagClosable(item),
          "disabled": _vm.state.isDisabled || item.disabled,
          "size": _vm.state.collapseTagSize,
          "hit": item.state ? item.state.hitState : item.hitState,
          "type": _vm.state.getTagType,
          "disable-transitions": ""
        },
        on: {
          "close": function close($event) {
            return _vm.deleteTag($event, item);
          }
        }
      }, [_c("tiny-tooltip", {
        attrs: {
          "effect": _vm.tooltipConfig.effect || "light",
          "placement": _vm.tooltipConfig.placement || "top",
          "popper-class": _vm.tooltipConfig.popperClass || ""
        },
        nativeOn: {
          "mouseenter": function mouseenter($event) {
            _vm.handleEnterTag($event, _vm.getValueKey(item));
          }
        },
        scopedSlots: _vm._u([_vm.state.tooltipContent[_vm.getValueKey(item)] ? {
          key: "content",
          fn: function fn() {
            return [!_vm.state.visible && _vm.state.overflow === index ? _c("span", [_vm._v(" " + _vm._s(item.state ? item.state.currentLabel + "... " : item.currentLabel + "... ") + " ")]) : _c("span", [_vm._t("label", function() {
              return [_vm._v(" " + _vm._s(item.state ? item.state.currentLabel : item.currentLabel) + " ")];
            }, {
              "item": _vm.getLabelSlotValue(item)
            })], 2)];
          },
          proxy: true
        } : null], null, true)
      }, [!_vm.state.visible && _vm.state.overflow === index ? _c("span", {
        staticClass: "tiny-select__tags-text"
      }, [_vm._v(" " + _vm._s(item.state ? item.state.currentLabel + "... " : item.currentLabel + "... ") + " ")]) : _c("span", {
        staticClass: "tiny-select__tags-text"
      }, [_vm._t("label", function() {
        return [_vm._v(" " + _vm._s(item.state ? item.state.currentLabel : item.currentLabel) + " ")];
      }, {
        "item": _vm.getLabelSlotValue(item)
      })], 2)])], 1);
    }), _vm.clickExpand && _vm.state.showCollapseTag ? _c("span", {
      staticClass: "tiny-select__collapse-text",
      on: {
        "click": function click($event) {
          return _vm.onClickCollapseTag($event);
        }
      }
    }, [_vm._v(" " + _vm._s(_vm.t("ui.select.collapse")) + " "), _c("icon-chevron-up")], 1) : _vm._e()]], 2) : _vm._e()]) : _c("span", {
      class: ["tiny-select__tags-text", "is-display-only", {
        "is-disabled": _vm.state.isDisabled
      }]
    }, [_c("span", _vm._l(_vm.state.selected, function(item) {
      return _c("span", {
        key: item.value
      }, [_vm._t("label", function() {
        return [_vm._v(_vm._s(item.state ? item.state.currentLabel : item.currentLabel))];
      }, {
        "item": item
      }), _vm._v("; ")], 2);
    }), 0)]), _c("input", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.filterable && !_vm.searchable && !_vm.state.selectDisabled,
        expression: "filterable && !searchable && !state.selectDisabled"
      }, {
        name: "model",
        rawName: "v-model",
        value: _vm.state.query,
        expression: "state.query"
      }],
      ref: "input",
      staticClass: "tiny-select__input",
      class: [_vm.state.selectSize ? "is-" + _vm.state.selectSize : ""],
      style: {
        "flex-grow": "1",
        width: _vm.state.inputLength / (_vm.state.inputWidth - 32) + "%",
        "max-width": _vm.state.inputWidth - 42 + "px",
        height: "auto"
      },
      attrs: {
        "type": "text",
        "disabled": _vm.state.selectDisabled,
        "autocomplete": _vm.autocomplete
      },
      domProps: {
        "value": _vm.state.query
      },
      on: {
        "focus": _vm.handleFocus,
        "blur": _vm.handleBlur,
        "keyup": _vm.managePlaceholder,
        "keydown": [_vm.resetInputState, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) return null;
          $event.preventDefault();
          return _vm.navigateOptions("next");
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) return null;
          $event.preventDefault();
          return _vm.navigateOptions("prev");
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
          $event.preventDefault();
          return _vm.selectOption.apply(null, arguments);
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) return null;
          $event.stopPropagation();
          $event.preventDefault();
          _vm.state.visible = false;
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "delete", [8, 46], $event.key, ["Backspace", "Delete", "Del"])) return null;
          return _vm.deletePrevTag.apply(null, arguments);
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) return null;
          _vm.state.visible = false;
        }],
        "compositionstart": _vm.handleComposition,
        "compositionupdate": _vm.handleComposition,
        "compositionend": _vm.handleComposition,
        "input": [function($event) {
          if ($event.target.composing) return;
          _vm.$set(_vm.state, "query", $event.target.value);
        }, _vm.debouncedQueryChange]
      }
    })]) : _vm._e(), !_vm.shape ? _c("tiny-input", {
      ref: "reference",
      class: {
        "is-focus": _vm.state.visible,
        overflow: _vm.state.overflow,
        "is-show-close": _vm.state.showClose,
        "show-copy": _vm.copyable,
        "show-clear": _vm.clearable
      },
      attrs: {
        "tiny_mode": "pc",
        "type": "text",
        "placeholder": _vm.state.currentPlaceholder,
        "name": _vm.name,
        "id": _vm.id,
        "autocomplete": _vm.autocomplete,
        "size": _vm.state.selectSize,
        "showTooltip": false,
        "disabled": _vm.state.selectDisabled,
        "readonly": _vm.state.readonly,
        "display-only": _vm.state.isDisplayOnly,
        "display-only-content": _vm.state.displayOnlyContent,
        "unselectable": _vm.state.readonly ? "on" : "off",
        "validate-event": false,
        "show-empty-value": _vm.showEmptyValue,
        "inputBoxType": _vm.inputBoxType,
        "tabindex": _vm.multiple && _vm.filterable ? "-1" : _vm.tabindex
      },
      on: {
        "focus": _vm.handleFocus,
        "blur": _vm.handleBlur,
        "keyup": _vm.debouncedOnInputChange,
        "keydown": [function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) return null;
          $event.stopPropagation();
          $event.preventDefault();
          return _vm.navigateOptions("next");
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) return null;
          $event.stopPropagation();
          $event.preventDefault();
          return _vm.navigateOptions("prev");
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
          $event.preventDefault();
          return _vm.selectOption.apply(null, arguments);
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) return null;
          $event.stopPropagation();
          $event.preventDefault();
          _vm.state.visible = false;
        }, function($event) {
          if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) return null;
          _vm.state.visible = false;
        }],
        "paste": _vm.debouncedOnInputChange,
        "mouseenter": _vm.onMouseenterNative,
        "mouseleave": _vm.onMouseleaveNative
      },
      nativeOn: {
        "compositionend": function compositionend($event) {
          return _vm.handleComposition.apply(null, arguments);
        }
      },
      scopedSlots: _vm._u([_vm.slots.prefix ? {
        key: "prefix",
        fn: function fn() {
          return [_vm._t("prefix")];
        },
        proxy: true
      } : null, {
        key: "suffix",
        fn: function fn() {
          return [_vm._t("suffix"), _vm.showLimitText && _vm.multiple && _vm.multipleLimit && !_vm.state.showCopy ? _c("span", {
            staticClass: "tiny-select__limit-txt"
          }, [_vm._v(" " + _vm._s(_vm.state.selected.length) + "/" + _vm._s(_vm.multipleLimit) + " ")]) : _vm.showProportion && _vm.state.selected.length > 0 && _vm.state.options.length > 1 ? _c("span", {
            staticClass: "tiny-select__proportion-txt"
          }, [_vm._v(" " + _vm._s(_vm.state.selected.length + "/" + _vm.state.options.length) + " ")]) : _vm._e(), _vm.state.showCopy ? _c("span", {
            staticClass: "tiny-select__copy",
            on: {
              "click": function click($event) {
                $event.stopPropagation();
                return _vm.handleCopyClick.apply(null, arguments);
              }
            }
          }, [_c("icon-copy", {
            staticClass: "tiny-svg-size tiny-select__caret"
          })], 1) : _vm._e(), _vm.state.showClose ? _c("icon-close", {
            staticClass: "tiny-svg-size tiny-select__caret tiny-select__close",
            on: {
              "click": _vm.handleClearClick,
              "mouseenter": function mouseenter($event) {
                _vm.state.inputHovering = true;
              }
            }
          }) : _vm._e(), _c(_vm.state.getIcon.icon, {
            directives: [{
              name: "show",
              rawName: "v-show",
              value: _vm.state.autoHideDownIcon ? !_vm.state.showClose && !(_vm.remote && _vm.filterable && !_vm.remoteConfig.showIcon) : !(_vm.remote && _vm.filterable && !_vm.remoteConfig.showIcon),
              expression: "\n              state.autoHideDownIcon\n                ? !state.showClose && !(remote && filterable && !remoteConfig.showIcon)\n                : !(remote && filterable && !remoteConfig.showIcon)\n            "
            }],
            tag: "component",
            class: ["tiny-svg-size", "tiny-select__caret", _vm.state.iconClass, {
              "is-reverse": !_vm.state.visible && _vm.state.getIcon.isDefault
            }, {
              "not-reverse": !_vm.state.getIcon.isDefault
            }],
            on: {
              "click": _vm.handleDropdownClick
            }
          })];
        },
        proxy: true
      }], null, true),
      model: {
        value: _vm.state.selectedLabel,
        callback: function callback($$v) {
          _vm.$set(_vm.state, "selectedLabel", $$v);
        },
        expression: "state.selectedLabel"
      }
    }) : _vm._e()];
  }), _c("transition", {
    attrs: {
      "name": "tiny-zoom-in-top"
    },
    on: {
      "before-enter": _vm.handleMenuEnter,
      "after-leave": _vm.doDestroy
    }
  }, [_c("tiny-select-dropdown", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.onCopying() && !_vm.hideDrop && _vm.state.visible && _vm.state.emptyText !== false,
      expression: "!onCopying() && !hideDrop && state.visible && state.emptyText !== false"
    }],
    ref: "popper",
    style: _vm.dropStyle,
    attrs: {
      "is-drop-inherit-width": _vm.isDropInheritWidth,
      "placement": _vm.placement,
      "append-to-body": _vm.popperAppendToBody,
      "popper-options": _vm.popperOptions
    }
  }, [_vm.shape && _vm.filterable ? _c("div", {
    staticClass: "tiny-select__filter-input",
    class: [_vm.remote && !_vm.state.options.length ? "tiny-select__remote-input" : ""]
  }, [_c("tiny-input", {
    ref: "input",
    attrs: {
      "placeholder": _vm.placeholder,
      "autofocus": ""
    },
    on: {
      "input": _vm.debouncedQueryChange,
      "focus": _vm.handleFocus
    },
    model: {
      value: _vm.state.query,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "query", $$v);
      },
      expression: "state.query"
    }
  })], 1) : _vm._e(), _vm.topCreate ? _c("div", {
    staticClass: "tiny-select__top-create"
  }, [_c("div", {
    on: {
      "click": function click($event) {
        return _vm.$emit("top-create-click", $event);
      }
    }
  }, [_c(((_vm$state$designConfi = _vm.state.designConfig) === null || _vm$state$designConfi === void 0 ? void 0 : (_vm$state$designConfi2 = _vm$state$designConfi.icons) === null || _vm$state$designConfi2 === void 0 ? void 0 : _vm$state$designConfi2.addIcon) || "icon-add-circle", {
    tag: "component"
  }), _c("span", [_vm._v(_vm._s(_vm.topCreateText))])], 1)]) : _vm._e(), _vm.renderType === "grid" ? _c("tiny-grid", _vm._b({
    ref: "selectGrid",
    attrs: {
      "auto-resize": "",
      "row-id": _vm.valueField,
      "select-config": _vm.buildSelectConfig(),
      "radio-config": _vm.buildRadioConfig(),
      "highlight-current-row": true,
      "columns": _vm.gridOp.columns,
      "data": _vm.state.gridData
    },
    on: {
      "select-all": _vm.selectChange,
      "select-change": _vm.selectChange,
      "radio-change": _vm.radioChange,
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      }
    }
  }, "tiny-grid", _vm.gridOp, false)) : _vm._e(), _vm.renderType === "tree" ? _c("tiny-tree", _vm._b({
    ref: "selectTree",
    attrs: {
      "filter-node-method": _vm.filterMethod,
      "props": Object.assign({
        label: _vm.textField,
        isLeaf: "isLeaf"
      }, _vm.treeOp.props),
      "expand-on-click-node": false,
      "icon-trigger-click-node": false,
      "node-key": _vm.valueField,
      "default-expand-all": _vm.state.isExpandAll,
      "check-strictly": _vm.treeOp.checkStrictly,
      "default-checked-keys": _vm.multiple ? _vm.state.defaultCheckedKeys : _vm.treeOp.defaultCheckedKeys || [],
      "current-node-key": !_vm.multiple ? _vm.state.currentKey : "",
      "show-checkbox": _vm.multiple
    },
    on: {
      "load-data": _vm.loadTreeData,
      "node-collapse": _vm.nodeCollapse,
      "node-expand": _vm.nodeExpand,
      "check": _vm.nodeCheckClick,
      "node-click": _vm.treeNodeClick
    }
  }, "tiny-tree", _vm.treeOp, false)) : _vm._e(), _vm.searchable ? _c("tiny-input", {
    staticClass: "tiny-select-dropdown__search",
    attrs: {
      "input-box-type": "underline",
      "placeholder": _vm.t("ui.search.placeholder")
    },
    on: {
      "update:modelValue": function updateModelValue($event) {
        return _vm.handleQueryChange(_vm.state.query);
      }
    },
    scopedSlots: _vm._u([{
      key: "prefix",
      fn: function fn() {
        return [_c("icon-search", {
          staticClass: "tiny-select-dropdown__search-prefix"
        })];
      },
      proxy: true
    }, {
      key: "suffix",
      fn: function fn() {
        return [_c("span", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.state.query,
            expression: "state.query"
          }],
          staticClass: "tiny-icon-close"
        }, [_c("icon-close", {
          on: {
            "click": _vm.clearSearchText
          }
        })], 1), _c("icon-search", {
          staticClass: "tiny-select-dropdown__search-suffix"
        })];
      },
      proxy: true
    }], null, false, 2405204655),
    model: {
      value: _vm.state.query,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "query", $$v);
      },
      expression: "state.query"
    }
  }) : _vm._e(), _vm.optimization && !~["grid", "tree"].indexOf(_vm.renderType) ? [_c("div", {
    style: {
      height: _vm.state.optimizeStore.recycleScrollerHeight + "px"
    }
  }, [_c("tiny-recycle-scroller", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.emptyFlag && !_vm.loading,
      expression: "!state.emptyFlag && !loading"
    }],
    ref: "scrollbar",
    staticStyle: {
      "height": "100%"
    },
    attrs: {
      "key-field": _vm.valueField,
      "list-class": ["tiny-select-dropdown__wrap"],
      "item-class": ["tiny-select-dropdown__item-view"],
      "items": _vm.state.datas,
      "item-size": _vm.state.optimizeOpts.optionHeight
    },
    scopedSlots: _vm._u([{
      key: "before",
      fn: function fn() {
        return [_vm.state.showNewOption ? _c("tiny-option", {
          attrs: {
            "value": _vm.state.query,
            "created": ""
          }
        }) : _vm._e()];
      },
      proxy: true
    }, {
      key: "default",
      fn: function fn(_ref) {
        var item = _ref.item;
        return [_vm._t("default", function() {
          return [_c("tiny-option", {
            key: "" + item[_vm.valueField],
            attrs: {
              "label": item[_vm.textField],
              "value": item[_vm.valueField],
              "disabled": item.disabled,
              "required": item.required,
              "highlight-class": item._highlightClass,
              "events": item.events,
              "icon": item.icon
            },
            on: {
              "mousedown": function mousedown($event) {
                $event.stopPropagation();
              }
            }
          })];
        }, {
          "item": item
        })];
      }
    }], null, true)
  })], 1)] : _vm._e(), !_vm.optimization && !~["grid", "tree"].indexOf(_vm.renderType) && !(_vm.state.isDisplayOnly && _vm.options) ? _c("tiny-scrollbar", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.options.length > 0 && !_vm.loading,
      expression: "state.options.length > 0 && !loading"
    }],
    ref: "scrollbar",
    class: {
      "is-empty": !_vm.allowCreate && _vm.state.query && _vm.state.filteredOptionsCount === 0
    },
    attrs: {
      "show": "",
      "tag": "ul",
      "wrap-class": ["tiny-select-dropdown__wrap"],
      "view-class": ["tiny-select-dropdown__list"]
    },
    on: {
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      }
    }
  }, [_vm._t("dropdown"), _vm.multiple && _vm.showCheck && _vm.showAlloption && !_vm.state.multipleLimit && !_vm.state.query && !_vm.remote ? _c("li", {
    staticClass: "tiny-option tiny-option_all tiny-select-dropdown__item",
    class: [{
      hover: _vm.state.hoverIndex === -9 && _vm.state.selectCls !== "checked-sur"
    }, {
      "selected": _vm.state.selectCls === "checked-sur"
    }],
    attrs: {
      "data-tag": "tiny-option"
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.toggleCheckAll(false);
      },
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      },
      "mouseenter": function mouseenter($event) {
        _vm.state.hoverIndex = -9;
      }
    }
  }, [_c("icon-" + _vm.state.selectCls, {
    tag: "component",
    class: ["tiny-svg-size", _vm.state.selectCls]
  }), _c("span", [_vm._v(_vm._s(_vm.allText || _vm.t("ui.base.all")))])], 1) : _vm._e(), _vm.multiple && _vm.showCheck && _vm.showAlloption && !_vm.state.multipleLimit && _vm.state.query && !_vm.state.emptyText && !_vm.remote ? _c("li", {
    staticClass: "tiny-option tiny-select-dropdown__item",
    class: [{
      hover: _vm.state.hoverIndex === -9 && _vm.state.filteredSelectCls !== "checked-sur"
    }, {
      "selected": _vm.state.filteredSelectCls === "checked-sur"
    }],
    attrs: {
      "data-tag": "tiny-option"
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.toggleCheckAll(true);
      },
      "mousedown": function mousedown($event) {
        $event.stopPropagation();
      },
      "mouseenter": function mouseenter($event) {
        _vm.state.hoverIndex = -9;
      }
    }
  }, [_c("icon-" + _vm.state.filteredSelectCls, {
    tag: "component",
    class: ["tiny-svg-size", _vm.state.filteredSelectCls]
  }), _c("span", [_vm._v(_vm._s(_vm.allText || _vm.t("ui.base.all")))])], 1) : _vm._e(), _vm.state.showNewOption ? _c("tiny-option", {
    attrs: {
      "value": _vm.state.query,
      "created": ""
    }
  }) : _vm._e(), _vm._t("default", function() {
    return _vm._l(_vm.state.datas, function(item) {
      return _c("tiny-option", {
        key: "" + item[_vm.valueField],
        attrs: {
          "label": item[_vm.textField],
          "value": item[_vm.valueField],
          "disabled": item.disabled,
          "required": item.required,
          "highlight-class": item._highlightClass,
          "events": item.events,
          "icon": item.icon
        },
        on: {
          "mousedown": function mousedown($event) {
            $event.stopPropagation();
          }
        }
      });
    });
  })], 2) : _vm._e(), _vm.renderType !== "grid" && _vm.renderType !== "tree" && _vm.state.emptyText && (!_vm.allowCreate || _vm.loading || _vm.allowCreate && _vm.state.emptyFlag) ? [_vm.loadingText || _vm.slots.empty ? _c("div", {
    staticClass: "tiny-select-dropdown__empty-wrap"
  }, [_vm.slots.empty ? _vm._t("empty") : _vm.showEmptyImage ? _c("span", {
    staticClass: "tiny-select-dropdown__empty-images"
  }) : _c("p", {
    staticClass: "tiny-select-dropdown__empty"
  }, [_vm._v(" " + _vm._s(_vm.state.emptyText) + " ")])], 2) : _c("div", {
    staticClass: "tiny-select-dropdown__loading",
    class: {
      "show-loading-icon": _vm.loading
    }
  }, [_vm.loading ? _c(_vm.state.designConfig && _vm.state.designConfig.icons && _vm.state.designConfig.icons.loadingIcon || "icon-loading-shadow", {
    tag: "component",
    staticClass: "circular"
  }) : [_vm.showEmptyImage ? _c("span", {
    staticClass: "tiny-select-dropdown__empty-images"
  }) : _c("span", {
    staticClass: "tiny-select-dropdown__empty"
  }, [_vm._v(" " + _vm._s(_vm.state.emptyText))])]], 2)] : _vm._e(), _vm._t("footer")], 2)], 1)], 2), _vm.hoverExpand && !_vm.state.isDisplayOnly ? _c("div", {
    staticClass: "tiny-select__placeholder"
  }, [_c("input", {
    staticClass: "tiny-input__inner",
    attrs: {
      "disabled": ""
    }
  })]) : _vm._e()]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
